(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KURNIK.PAS                                                     *)
(*  Obsah: program pro tvorbu a editaci kurzoru mysi (*.KUR)               *)
(*         pro jednotku Mys4                                               *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 15.12.2021                                            *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: provozni soubory pro Woknows4                            *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
{Soubor s kurzorem k editaci lze zadat bud jako prvni parametr programu nebo
vyberem z okna po spusteni programu.
Soubor s paletou jde zadat jako druhy parametr nebo taky vyberem. Pokud se
vyber palety stornuje, zustane nastavena standardni paleta. Jmeno souboru
s paletou nelze zadat jako jediny parametr programu - vzdycky musi byt bud
zadny nebo jeden (kurzor) nebo dva (kurzor a paleta).}
program Editor_na_kurzory;
{$I-,R-,S-,X-}
uses mys4,vesa2,grafika4,woknows4,klavesy2,konst,errmsg,paleta2,cfg,retezce;
var JmenoSouboru:string;
    o:word;{pro klavesnici}
    barva,bp:byte;{barva pro kresleni a pozadi}
    i,j:word;
    tk:tkurzor;{pro testovani}
    platno:array[0..47,0..47] of byte;{pracovni pro ulozeni bitmapy}
    hsx,hsy:shortint;{souradnice aktivniho bodu na platne}

procedure nahled;
Begin
kvyp;
__putimage(592,0,48,48,@platno);
kzap;
End;{nahled}

procedure znacky(normalne:boolean);{vyznaci polohu aktivniho bodu}
var b:byte;
Begin
kvyp;
if normalne then b:=10 else b:=6;{normalne znamena, ze se kresli, jinak se mazou}
__rectangle(10*hsx,10*hsy,10*hsx+10,10*hsy+10,b,0);{aktivni bod}
kzap;
End;{znacky}

procedure mrizka;{vykresli tu hnedou mrizku, do ktere se kresli, + znacky}
Begin
kvyp;
for i:=0 to 47 do begin
                  _hline(0,479,i*10,6);
                  _vline(i*10,0,479,6,0);
                  end;
_vline(480,0,479,6,0);
znacky(true);
End;{mrizka}

procedure vykresli;
var x,y:word;
    b:byte;
Begin
kvyp;
for y:=0 to 47 do
 for x:=0 to 47 do begin
                   b:=platno[y,x];
                   if b=0 then b:=bp;
                   _bar(x*10+1,y*10+1,x*10+9,y*10+9,b);
                   end;
kzap;
End;{vykresli}

procedure pozadi;
var i,j:word;
    sbp,b:byte;
Begin
bp:=vyberbarvuokno('Barva pozad:',bp);
kvyp;
_bar(0,0,479,479,bp);
mrizka;
vykresli;
nahled;
End;{pozadi}

procedure VyberSouboru(proUkladani:boolean);
var pom:string[80];
Begin
pom:=vybersouborokno('Soubor s kurzorem',jmenosouboru,'*.KUR',proukladani);
if pom<>'' then
  begin
  jmenosouboru:=pom;
  napis(486,60,2,0,zkratretezec(jmenosouboru,19,0,12)+'           ');
  end;
End;{vybersouboru}

procedure Nacti_Paletu(jmeno:string);
var pal:rgbpal256;
Begin
if jmeno='' then jmeno:=vybersouborokno('Paleta','','*.PAL',false);
if jmeno<>'' then
  begin
  if nactipaletu(pal,jmeno) then nastavceloupaletu(pal);
  end;
End;{nacti_paletu}

procedure nacti;{nacte kurzor z aktualniho souboru do pole}
var f:file;
    lhx,lhy:integer;
    sirka,vyska:byte;{sirka a vyska kurzoru (v pixelech)}
Begin
if jmenosouboru='' then vybersouboru(false);
if jmenosouboru='' then exit;
hsx:=0; hsy:=0;
sirka:=0; vyska:=0;
fillchar(platno,sizeof(platno),0);
assign(f,jmenosouboru);
reset(f,1);
if ioresult<>0 then
  begin
  okokno('Soubor '+jmenosouboru+' neexistuje nebo nejde otevt.');
  exit;
  end;
{nacteni a kontrola rozmeru:}
blockread(f,sirka,1);
blockread(f,vyska,1);
if (sirka=0)or(sirka>48)or(vyska=0)or(vyska>48)or(ioresult<>0) then
  okokno('Neplatn rozmry kurzoru:|ka='+nastr(sirka)+', vka='+nastr(vyska))
else
  begin
  {vystredeni bitmapy na platno:}
  lhx:=(48-sirka) div 2;
  lhy:=(48-vyska) div 2;
  {aktivni bod:}
  blockread(f,hsx,1);
  blockread(f,hsy,1);
  inc(hsx,lhx);
  inc(hsy,lhy);
  if(hsx<0)or(hsx>47)or(hsy<0)or(hsy>47)or(ioresult<>0) then
    begin
    okokno('Souadnice aktivnho bodu vychzej mimo kreslic plochu. '
          +'Pesouvm je do levho hornho rohu kurzoru (0,0).');
    hsx:=lhx; hsy:=lhy;
    end;
  {bitmapa:}
  for i:=0 to vyska-1 do blockread(f,platno[i+lhy,lhx],sirka);
  if ioresult<>0 then okokno('Chyba pi natn obrazovch dat ze souboru.');
  end;
close(f);
if ioresult=0 then ;
vykresli; mrizka; nahled;
End;{nacti}

procedure uloz;{ulozi do aktualniho souboru}
var f:file;
    sirka,vyska:byte;
    _hsx,_hsy:shortint;
    _b:byte;
    lhx,lhy,pdx,pdy,x,y:integer;
Begin
if jmenosouboru='' then vybersouboru(true);
if jmenosouboru='' then exit;
kvyp;{indikace, ze se neco deje}
{zjisteni rozmeru bitmapy:}
lhy:=-1;
y:=0;
 repeat
 for x:=0 to 47 do if platno[y,x]<>0 then lhy:=y;
 inc(y);
 until (lhy>0)or(y>47);
if lhy<0 then begin
              okokno('Kreslic plocha je przdn, nen co ukldat.');
              exit;
              end;
{jestli prosla kontrola lhy, tak uz projde i vsechno ostatni:}
pdy:=-1;
y:=47;
 repeat
 for x:=0 to 47 do if platno[y,x]<>0 then pdy:=y;
 dec(y);
 until (pdy>0)or(y<0);
lhx:=-1;
x:=0;
 repeat
 for y:=lhy to pdy do if platno[y,x]<>0 then lhx:=x;
 inc(x);
 until (lhx>0)or(x>47);
pdx:=-1;
x:=47;
 repeat
 for y:=lhy to pdy do if platno[y,x]<>0 then pdx:=x;
 dec(x);
 until (pdx>0)or(x<0);
{rozmery a souradnice:}
sirka:=pdx-lhx+1;
vyska:=pdy-lhy+1;
_hsx:=hsx-lhx;
_hsy:=hsy-lhy;
{ukladani:}
assign(f,jmenosouboru);
rewrite(f,1);
if ioresult<>0 then begin
                    okokno('Soubor '+jmenosouboru+' nejde otevt pro zpis.');
                    exit;
                    end;
blockwrite(f,sirka,1);
blockwrite(f,vyska,1);
blockwrite(f,_hsx,1);
blockwrite(f,_hsy,1);
for y:=lhy to pdy do blockwrite(f,platno[y,lhx],sirka);
close(f);
if ioresult<>0 then okokno('Chyba pi zpisu do souboru '+jmenosouboru);
kzap;{indikace, ze je hotovo}
End;{uloz}

(*----------------------------------------------------------------*)

BEGIN
cfgsoubor:='KURNIK.CFG';
_setmode(_640x480);
initmys; nactinastavenimysi;
initwoknows(true,true,true);
hsx:=0; hsy:=0;
fillchar(platno,sizeof(platno),0);
barva:=15; bp:=5;
_bar(0,0,479,479,bp);
_vline(591,0,48,7,0); _hline(591,639,48,7);{ramecek kolem nahledu}
{popisky:}
__print(490,10,7,0,'N: Nhled '+psipkazn);

__print(490,50,7,0,'Soubor:');
__print(490,70,7,0,'Enter: vybrat jin');

__print(490,90,7,0,'F2: Ulo');
__print(490,100,7,0,'F3: Nati');

__print(490,120,7,0,'lev mytko:');
__print(560,130,7,0,'kreslen');
__print(490,140,7,0,'prav mytko:');
__print(560,150,7,0,'mazn');

__print(490,170,7,0,'B: barva pera');
__print(490,180,7,0,'P: barva pozad');
__print(490,190,7,0,'A: vbr palety');

__print(490,200,7,0,lsipkazn+psipkazn+hsipkazn+dsipkazn+': aktivn bod');

__print(490,220,7,0,'T: test kurzoru');
__print(500,230,7,0,'(uloenho)');

__print(490,250,7,0,'M: nastaven myi');

__print(490,270,7,0,'Esc: konec');

__rectangle(552,451,639,479,9,0);
__print(561,456,9,0,'Mircosoft');
__print(572,466,9,0,'Kurnik');

if paramcount=2 then nacti_paletu(paramstr(2));
if paramcount<>0 then jmenosouboru:=paramstr(1)
                 else jmenosouboru:='';
napis(486,60,2,0,zkratretezec(jmenosouboru,19,0,12)+'           ');

nacti;
vykresli; mrizka; znacky(true);
 Repeat
 cekej;
 if lmys and mysvpoli(0,0,479,479) then
   begin{kresleni}
   j:=xmys div 10; i:=ymys div 10;
   platno[i,j]:=barva;
   kvyp; _bar(10*j+1,10*i+1,10*j+9,10*i+9,barva); kzap;
   end;
 if pmys and mysvpoli(0,0,479,479) then
   begin{mazani}
   j:=xmys div 10; i:=ymys div 10;
   platno[i,j]:=0;
   kvyp; _bar(10*j+1,10*i+1,10*j+9,10*i+9,bp); kzap;
   end;
 if keypressed then
   begin
   o:=xreadkey;
   case o of
    {barvy:}
    ord('b'):barva:=vyberbarvuokno('Barva pro kreslen:',barva);
    ord('p'):pozadi;
    ord('n'):nahled;
    ord('t'):if jmenosouboru<>'' then
               begin
               nactikurzor2(tk,jmenosouboru);
               if tk.kdata=nil then
                 okokno('Kurzor je nutn nejdv uloit.')
               else
                 begin
                 nastavkurzor(tk);
                 infokno(0,480,'Testovn ukonte kliknutm nebo stiskem libovoln klvesy.',true);
                 nastavkurzor(wokkurzor);
                 zruskurzor(tk);
                 end;
               end;
    {posun aktivniho bodu:}
    xlsipka:if hsx>0 then begin znacky(false); dec(hsx); znacky(true); end;
    xpsipka:if hsx<47 then begin znacky(false); inc(hsx); znacky(true); end;
    xhsipka:if hsy>0 then begin znacky(false); dec(hsy); znacky(true); end;
    xdsipka:if hsy<47 then begin znacky(false); inc(hsy); znacky(true); end;
    {nacteni a ulozeni:}
    xf3:nacti;
    xf2:uloz;
    13:vybersouboru(false);
    ord('a'):nacti_paletu('');
    ord('m'):nastavmysokno(true);
   end;{case}
   end;{if}
 Until o=27;
zruswoknows;
_setmode(0);
END.

{Struktura dat v souboru *.KUR (muj neoficialni format):

 sirka kurzoru v pixelech (byte)
 vyska kurzoru v pixelech (byte)
 xova souradnice aktivniho bodu v pixelech (shortint)
 yova souradnice aktivniho bodu v pixelech (shortint)
 bitmapa kurzoru (array[1..vyska,1..sirka] of byte)

Bitmapa je vlastni obrazek kurzoru - seznam pixelu razeny po radcich, kde
1 byte = 1 pixel. 256 barev, hodnota 0 znamena pruhledny pixel.
Levy horni roh bitmapy se na obrazovce objevi na souradnicich
[xmys - x aktivniho bodu, ymys - y aktivniho bodu].
}
